///////////////////////////////////////////////////////////////////////////////
// Project description
// 
// Name: myChip8
//
// Author: Laurence Muller
// Contact: laurence.muller@gmail.com
//
// License: GNU General Public License (GPL) v2 
// ( http://www.gnu.org/licenses/old-licenses/gpl-2.0.html )
//
// Copyright (C) 2011 Laurence Muller / www.multigesture.net
///////////////////////////////////////////////////////////////////////////////

class chip8 {
	public:
		chip8();
		~chip8();
		
		bool drawFlag;

		void emulateCycle();
		void debugRender();
		bool loadApplication(const char * filename);		

// Chip8
		unsigned char  gfx[64 * 32];	// Total amount of pixels: 2048
		unsigned char  key[16];			

	private:	
		unsigned short pc;				// Program counter
		unsigned short opcode;			// Current opcode
		unsigned short I;				// Index register
		unsigned short sp;				// Stack pointer
		
		unsigned char  V[16];			// V-regs (V0-VF)
		unsigned short stack[16];		// Stack (16 levels)
		unsigned char  memory[4096];	// Memory (size = 4k)		
				
		unsigned char  delay_timer;		// Delay timer
		unsigned char  sound_timer;		// Sound timer		

		void init();
};
